Loading...
Searching...
No Matches
pcl::ColorModality< PointInT > Class Template Reference

`#include <pcl/recognition/color_modality.h>`

Inheritance diagram for pcl::ColorModality< PointInT >:

## Classes

struct | Candidate

## Public Types

using | PointCloudIn = pcl::PointCloud<PointInT>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud
using | PointCloudPtr
using | PointCloudConstPtr
using | PointIndicesPtr
using | PointIndicesConstPtr

## Public Member Functions

| ColorModality ()
virtual | ~ColorModality ()=default
QuantizedMap & | getQuantizedMap ()
| Returns a reference to the internally computed quantized map.
QuantizedMap & | getSpreadedQuantizedMap ()
| Returns a reference to the internally computed spread quantized map.
void | extractFeatures (const MaskMap &mask, std::size_t nr_features, std::size_t modalityIndex, std::vector< QuantizedMultiModFeature > &features) const
| Extracts features from this modality within the specified mask.
virtual void | setInputCloud (const typename PointCloudIn::ConstPtr &cloud)
| Provide a pointer to the input dataset (overwrites the PCLBase::setInputCloud method).
virtual void | processInputData ()
Public Member Functions inherited from pcl::QuantizableModality
| QuantizableModality ()
| Constructor.
virtual | ~QuantizableModality ()
| Destructor.
virtual void | extractAllFeatures (const MaskMap &mask, std::size_t nr_features, std::size_t modality_index, std::vector< QuantizedMultiModFeature > &features) const =0
| Extracts all possible features from the modality within the specified mask.
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor.
| PCLBase (const PCLBase &base)
| Copy constructor.
virtual | ~PCLBase ()=default
| Destructor.
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset.
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset.
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data.
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud.
IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used.
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used.
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code.

## Protected Member Functions

void | quantizeColors ()
void | filterQuantizedColors ()
void | computeDistanceMap (const MaskMap &input, DistanceMap &output) const
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation.
bool | deinitCompute ()
| This method should get called after finishing the actual computation.

## Static Protected Member Functions

static int | quantizeColorOnRGBExtrema (const float r, const float g, const float b)

## Additional Inherited Members

Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset.
IndicesPtr | indices_
| A pointer to the vector of point indices to use.
bool | use_indices_
| Set to true if point indices are used.
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud.

## Detailed Description

template<typename PointInT>
class pcl::ColorModality< PointInT >

Definition at line 59 of file color_modality.h.

## Member Typedef Documentation

## PointCloudIn

template<typename PointInT>

using pcl::ColorModality< PointInT >::PointCloudIn = pcl::PointCloud<PointInT>

Definition at line 82 of file color_modality.h.

## Constructor & Destructor Documentation

## ColorModality()

template<typename PointInT>

pcl::ColorModality< PointInT >::ColorModality | ( |  | ) |

Definition at line 145 of file color_modality.h.

## ~ColorModality()

template<typename PointInT>

virtual pcl::ColorModality< PointInT >::~ColorModality | ( |  | ) |

virtual default

## Member Function Documentation

## computeDistanceMap()

template<typename PointInT>

void pcl::ColorModality< PointInT >::computeDistanceMap | ( | const MaskMap & | input,
|  | DistanceMap & | output ) const

protected

Definition at line 482 of file color_modality.h.

References pcl::DistanceMap::getData(), pcl::MaskMap::getData(), pcl::MaskMap::getHeight(), pcl::MaskMap::getWidth(), and pcl::DistanceMap::resize().

Referenced by extractFeatures().

## extractFeatures()

template<typename PointInT>

void pcl::ColorModality< PointInT >::extractFeatures | ( | const MaskMap & | mask,
|  | std::size_t | nr_features,
|  | std::size_t | modality_index,
|  | std::vector< QuantizedMultiModFeature > & | features ) const

virtual

Extracts features from this modality within the specified mask.

Parameters

  [in] | mask | defines the areas where features are searched in.
  [in] | nr_features | defines the number of features to be extracted (might be less if not sufficient information is present in the modality).
  [in] | modality_index | the index which is stored in the extracted features.
  [out] | features | the destination for the extracted features.

Implements pcl::QuantizableModality.

Definition at line 170 of file color_modality.h.

References pcl::ColorModality< PointInT >::Candidate::bin_index, computeDistanceMap(), pcl::ColorModality< PointInT >::Candidate::distance, pcl::MaskMap::getHeight(), pcl::MaskMap::getWidth(), pcl::QuantizedMultiModFeature::modality_index, pcl::QuantizedMultiModFeature::quantized_value, pcl::ColorModality< PointInT >::Candidate::x, pcl::QuantizedMultiModFeature::x, pcl::ColorModality< PointInT >::Candidate::y, and pcl::QuantizedMultiModFeature::y.

## filterQuantizedColors()

template<typename PointInT>

void pcl::ColorModality< PointInT >::filterQuantizedColors | ( |  | ) |

protected

Definition at line 355 of file color_modality.h.

References pcl::PCLBase< PointInT >::input_.

Referenced by processInputData().

## getQuantizedMap()

template<typename PointInT>

QuantizedMap & pcl::ColorModality< PointInT >::getQuantizedMap | ( |  | ) |

inline virtual

Returns a reference to the internally computed quantized map.

Implements pcl::QuantizableModality.

Definition at line 89 of file color_modality.h.

## getSpreadedQuantizedMap()

template<typename PointInT>

QuantizedMap & pcl::ColorModality< PointInT >::getSpreadedQuantizedMap | ( |  | ) |

inline virtual

Returns a reference to the internally computed spread quantized map.

Implements pcl::QuantizableModality.

Definition at line 95 of file color_modality.h.

## processInputData()

template<typename PointInT>

void pcl::ColorModality< PointInT >::processInputData | ( |  | ) |

virtual

Definition at line 153 of file color_modality.h.

References filterQuantizedColors(), quantizeColors(), and pcl::QuantizedMap::spreadQuantizedMap().

## quantizeColorOnRGBExtrema()

template<typename PointInT>

int pcl::ColorModality< PointInT >::quantizeColorOnRGBExtrema | ( | const float | r,
|  | const float | g,
|  | const float | b )

inline static protected

Definition at line 430 of file color_modality.h.

Referenced by quantizeColors().

## quantizeColors()

template<typename PointInT>

void pcl::ColorModality< PointInT >::quantizeColors | ( |  | ) |

protected

Definition at line 332 of file color_modality.h.

References pcl::PCLBase< PointInT >::input_, and quantizeColorOnRGBExtrema().

Referenced by processInputData().

## setInputCloud()

template<typename PointInT>

virtual void pcl::ColorModality< PointInT >::setInputCloud | ( | const typename PointCloudIn::ConstPtr & | cloud | ) |

inline virtual

Provide a pointer to the input dataset (overwrites the PCLBase::setInputCloud method).

Parameters

  cloud | the const boost shared pointer to a PointCloud message

Definition at line 108 of file color_modality.h.

References pcl::PCLBase< PointInT >::input_.

The documentation for this class was generated from the following file:

- pcl/recognition/color_modality.h